<?php

use YesWiki\Core\YesWikiAction;
use YesWiki\Bazar\Service\EntryManager;

include_once('includes/email.inc.php');

class MailAnnuaireAction extends YesWikiAction
{
    public function run()
    {
        $output = '';
        if ($this->wiki->userIsAdmin()) {
            $entryManager = $this->getService(EntryManager::class);
            $peoples = [];
            // get all users
            $res = $entryManager->search([
                'queries' => '', // Sélection par clé-valeur
                'formsIds' => [57,15,54,18,60], // Types de fiches (par ID de formulaire)
                'user' => '', // N'affiche que les fiches d'un utilisateur
                'keywords' => '', // Mots-clés pour la recherche fulltext
                'searchOperator' => 'OR', // Opérateur à appliquer aux mots-clés
                'minDate' => '', // Date minimale des fiches
                'correspondance' => ''
            ]);
            foreach ($res as $k => $r) {
               if (empty($r['yunohost_username'])) {
                    $peoples[$k] = [
                        'bf_titre' => $r['bf_titre'],
                        'id_fiche' => $r['id_fiche'],
                        'yunohost_username' => $r['yunohost_username'] ?? '',
                        'bf_mail' => $r['bf_mail']
                    ];
                }
            }
            $output .= 'Total de personnes ayant a créer ses identifiants : ' . count($peoples) . '<br />';

            // format the mail
            $subject = '[Réseau Smart Academy] RAPPEL : mettez à jour votre fiche annuaire pour créer votre identifiant unique';
            $from = 'support@apps.reseau.s-mart.fr';
            $fromname = 'Réseau Smart Academy';
            $to = '';
            $messageend = '
Saisissez les champs manquants demandés dans le formulaire et sauvegardez, vous recevrez un mail de confirmation.

Ensuite, vous devrez vous connecter une première fois seulement sur les espaces Réseau Smart Academy puis vous serez identifié.es pour une durée de 3 mois (sauf suppression des cookies). Pour le forum, toujours avec ces mêmes identifiants, il sera demandé à la première connexion de créer un pseudo pour ce forum, c\'est l\'ultime action à effectuer pour ensuite être tranquille !

Pour toute incompréhension ou difficulté technique, n\'hésitez pas à nous contacter par le formulaire de contact du site sur https://reseau.s-mart.fr/?FormulaireContact .

Merci de faire cette modification au plus vite, sans quoi vous ne pourrez pas interagir sur S.mart Academy.

Au plaisir vous retrouver prochainement sur la plateforme !

Lionel Roucoules, Directeur du Réseau Smart Academy';
            foreach ($peoples as $k => $fiche) {
    		$to = $fiche['bf_mail'] ?? '';
		$message = 'Bonjour,' . PHP_EOL . PHP_EOL .

'La plateforme Réseau Smart Academy évolue et propose maintenant un identifiant unique pour vous connecter au réseau central, à votre communauté (Doctorants, Fabadd-Académie, Ingénieurs techniciens, Sciences humaines et sociales), ainsi qu\'au forum.' . PHP_EOL . PHP_EOL .

'Pour créer votre identifiant et le mot de passe de votre choix, rendez-vous sur votre fiche :' . PHP_EOL . PHP_EOL .
$GLOBALS['wiki']->href('edit', $fiche['id_fiche']);

                $message .= PHP_EOL . $messageend;
                $output .= '<h2>' . $subject . '</h2>';
                $output .=  '<em>Pour ' . $to . '</em> - <a href="' . $GLOBALS['wiki']->href('', '', 'sendmail=' . $k) . '">Envoyer le mail</a><br /><br />';
                $output .=  nl2br($message);
                $output .=  '<hr />';
                if (!empty($_GET['sendmail']) && ($_GET['sendmail'] == $k || $_GET['sendmail'] == 'all')) {
                    send_mail($from, $fromname, $to, $subject, $message, nl2br($message));
                }
            }
        } else {
            $output .= 'Faut etre admin';
        }
        return $output;
    }
}

